const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Barter_offersDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const barter_offers = await db.barter_offers.create(
      {
        id: data.id || undefined,

        offer_details: data.offer_details || null,
        offer_date: data.offer_date || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await barter_offers.setPartner(data.partner || null, {
      transaction,
    });

    await barter_offers.setKooperatif(data.kooperatif || null, {
      transaction,
    });

    return barter_offers;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const barter_offersData = data.map((item, index) => ({
      id: item.id || undefined,

      offer_details: item.offer_details || null,
      offer_date: item.offer_date || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const barter_offers = await db.barter_offers.bulkCreate(barter_offersData, {
      transaction,
    });

    // For each item created, replace relation files

    return barter_offers;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const barter_offers = await db.barter_offers.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.offer_details !== undefined)
      updatePayload.offer_details = data.offer_details;

    if (data.offer_date !== undefined)
      updatePayload.offer_date = data.offer_date;

    updatePayload.updatedById = currentUser.id;

    await barter_offers.update(updatePayload, { transaction });

    if (data.partner !== undefined) {
      await barter_offers.setPartner(
        data.partner,

        { transaction },
      );
    }

    if (data.kooperatif !== undefined) {
      await barter_offers.setKooperatif(
        data.kooperatif,

        { transaction },
      );
    }

    return barter_offers;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const barter_offers = await db.barter_offers.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of barter_offers) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of barter_offers) {
        await record.destroy({ transaction });
      }
    });

    return barter_offers;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const barter_offers = await db.barter_offers.findByPk(id, options);

    await barter_offers.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await barter_offers.destroy({
      transaction,
    });

    return barter_offers;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const barter_offers = await db.barter_offers.findOne(
      { where },
      { transaction },
    );

    if (!barter_offers) {
      return barter_offers;
    }

    const output = barter_offers.get({ plain: true });

    output.partner = await barter_offers.getPartner({
      transaction,
    });

    output.kooperatif = await barter_offers.getKooperatif({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userKooperatif = (user && user.kooperatif?.id) || null;

    if (userKooperatif) {
      if (options?.currentUser?.kooperatifId) {
        where.kooperatifId = options.currentUser.kooperatifId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.partners,
        as: 'partner',

        where: filter.partner
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.partner
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.partner
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.kooperatif,
        as: 'kooperatif',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.offer_details) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'barter_offers',
            'offer_details',
            filter.offer_details,
          ),
        };
      }

      if (filter.offer_dateRange) {
        const [start, end] = filter.offer_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            offer_date: {
              ...where.offer_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            offer_date: {
              ...where.offer_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.kooperatif) {
        const listItems = filter.kooperatif.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          kooperatifId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.kooperatifId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.barter_offers.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('barter_offers', 'offer_details', query),
        ],
      };
    }

    const records = await db.barter_offers.findAll({
      attributes: ['id', 'offer_details'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['offer_details', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.offer_details,
    }));
  }
};
